package at.jku.koppensteiner.androgios;


import android.graphics.Color;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import at.jku.koppensteiner.androgios.nagios.NagiosInstance;
import at.jku.koppensteiner.androgios.nagios.model.HostGroup;
import at.jku.koppensteiner.androgios.nagios.model.MonitoringModel;

public class HostGroupsActivity extends AbstractModelActivity{

	private class HostGroupsAdapter extends BaseAdapter{

		private MonitoringModel currentModel;
		private int size;
		
		public HostGroupsAdapter(){
			currentModel = instance.model;
			size = instance.model.hostGroups.size();
		}
		
		@Override
		public int getCount() {
			return size==0?1:size;
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return getItem(position).hashCode();
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			
			TextView txtGroupName = new TextView(HostGroupsActivity.this);
			txtGroupName.setTextSize(TypedValue.COMPLEX_UNIT_PT, 10);
			
			if(size==0){
				txtGroupName.setText(R.string.nothingToDisplay);
				return txtGroupName;
			}
			
			HostGroup hg = currentModel.hostGroups.get(position);
			LinearLayout ll = new LinearLayout(HostGroupsActivity.this);
			ll.setOrientation(LinearLayout.VERTICAL);
			
			txtGroupName.setText(instance.model.hostGroups.get(position).hostGroupName);
			ll.addView(txtGroupName);
			
			TextView txtData = new TextView(HostGroupsActivity.this);
			
			
			txtData.setText(getString(R.string.hostsHeader));
			ll.addView(txtData);
			if(!hg.hostStatusSummary.hostsUp.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.hostStatusSummary.hostsUp);
				txtData.setTextColor(Color.GREEN);
				ll.addView(txtData);
			}
			if(!hg.hostStatusSummary.hostsDown.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.hostStatusSummary.hostsDown);
				txtData.setTextColor(Color.RED);
				ll.addView(txtData);
			}
			if(!hg.hostStatusSummary.hostsUnreachable.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.hostStatusSummary.hostsUnreachable);
				txtData.setTextColor(Color.RED);
				ll.addView(txtData);
			}
			if(!hg.hostStatusSummary.hostsPending.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.hostStatusSummary.hostsPending);
				ll.addView(txtData);
			}
			
			txtData = new TextView(HostGroupsActivity.this);
			txtData.setText( getString(R.string.servicesHeader));
			ll.addView(txtData); // OK, warning, critical, unknown, pending
			if(!hg.serviceStatusSummary.servicesOk.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.serviceStatusSummary.servicesOk);
				txtData.setTextColor(Color.GREEN);
				ll.addView(txtData);
			}
			if(!hg.serviceStatusSummary.servicesWarning.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.serviceStatusSummary.servicesWarning);
				txtData.setTextColor(Color.YELLOW);
				ll.addView(txtData);
			}
			if(!hg.serviceStatusSummary.servicesCritical.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.serviceStatusSummary.servicesCritical);
				txtData.setTextColor(Color.RED);
				ll.addView(txtData);
			}
			if(!hg.serviceStatusSummary.servicesUnknown.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.serviceStatusSummary.servicesUnknown);
				txtData.setTextColor(Color.RED);
				ll.addView(txtData);
			}
			if(!hg.serviceStatusSummary.servicesPending.equals("")){
				txtData = new TextView(HostGroupsActivity.this);
				txtData.setText(hg.serviceStatusSummary.servicesPending);
				ll.addView(txtData);
			}
			

			return ll;
		}
		
	}
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.abstract_model_layout);
		Bundle extras = getIntent().getExtras();
		if(extras==null || !extras.getBoolean("POLLED", false)){
			poll();
			getIntent().putExtra("POLLED", true);
		}else{
			update();
		}
		
	}
	
	@Override
	protected void poll(){
		super.poll();
		instance.poll(NagiosInstance.URL_HOSTGROUPS);               
	}

	@Override
	protected void update() {
		super.update();
		
		if(instance.model.lastParsed != MonitoringModel.HOSTGROUPS)return;
		
		ListView list = (ListView) findViewById(R.id.listViewModel);
		list.setAdapter(new HostGroupsAdapter());
		
	}
}
