package at.jku.koppensteiner.androgios;


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Button;
import at.jku.koppensteiner.androgios.nagios.MasterController;
import at.jku.koppensteiner.androgios.util.FilterHelper;

public class HostListFilterActivity extends Activity{

	private class HostListFilterAdapter extends BaseAdapter{

		private LinearLayout llStatusTypes;
		private LinearLayout llProps;
		
		public HostListFilterAdapter(){
			init();
		}
		
		private void init(){
			llStatusTypes = new LinearLayout(HostListFilterActivity.this);
			llStatusTypes.setOrientation(LinearLayout.VERTICAL);
			for(int i=0;i<hostStatusTypes.length;i++){
				hostStatusTypes[i].setChecked(true);
				llStatusTypes.addView(hostStatusTypes[i]);
			}
			
			llProps = new LinearLayout(HostListFilterActivity.this);
			llProps.setOrientation(LinearLayout.VERTICAL);
			for(int i=0;i<hostProps.length;i++){
				llProps.addView(hostProps[i]);
			}
		}
		
		@Override
		public int getCount() {
			return 2; 
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return getItem(position).hashCode();
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			
			switch(position){
			case 0:
				return llProps;
			case 1:
				return llStatusTypes;
			}
			return null;
		}
		
		
		
	}
	
	private CheckBox[] hostStatusTypes;
	private CheckBox[] hostProps;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.host_list_filter_layout);
		
		hostStatusTypes = FilterHelper.getHostStatusTypeCheckBoxes(this);
		hostProps = FilterHelper.getHostPropsCheckBoxes(this);
		
		update();
	}

	
	protected void update() {
		
		((TextView)findViewById(R.id.textViewHostListFilter)).setText(R.string.chooseFilterCriteria);
		ListView list = (ListView) findViewById(R.id.listViewHostListFilter);
		list.setAdapter(new HostListFilterAdapter());
		
		
		Button btn = ((Button)findViewById(R.id.buttonStartHostListActivity));
		btn.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				int statusTypeParam = FilterHelper.getFilterParam(hostStatusTypes);
				int propsParam = FilterHelper.getFilterParam(hostProps);
				
				Intent intent = new Intent();
				intent.putExtra("FILTERED", true);
				intent.putExtra("HOSTSTATUSTYPES", statusTypeParam);
				intent.putExtra("HOSTPROPS", propsParam);
				intent.setClass(MasterController.getInstance().getAppCtx(), HostListActivity.class);
				startActivity(intent);
			}
		});
		
	}
	
	
	
}
