package at.jku.koppensteiner.androgios;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import at.jku.koppensteiner.androgios.nagios.MasterController;
import at.jku.koppensteiner.androgios.nagios.NagiosInstance;
import at.jku.koppensteiner.androgios.nagios.model.TacticalOverview;
import at.jku.koppensteiner.androgios.service.PollingService;
import at.jku.koppensteiner.androgios.util.DateHelper;
import at.jku.koppensteiner.androgios.util.MenuHelper;

public class MonitoringFeaturesActivity extends Activity{

	
	
	private class MonitoringFeaturesAdapter extends BaseAdapter{
		
		
		private TacticalOverview currentTac;
		
		public MonitoringFeaturesAdapter(){
			currentTac = instance.tacticalOverview;
		}
		
		@Override
		public int getCount() {
			return 5;
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return getItem(position).hashCode();
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			TextView txtHeader = new TextView(MonitoringFeaturesActivity.this);
			TextView txtDataHosts = new TextView(MonitoringFeaturesActivity.this);
			TextView txtDataServices = new TextView(MonitoringFeaturesActivity.this);
			LinearLayout ll = new LinearLayout(MonitoringFeaturesActivity.this);
			
			ll.setOrientation(LinearLayout.VERTICAL);
			txtDataHosts.setTextSize(TypedValue.COMPLEX_UNIT_PT, 8);
			txtDataServices.setTextSize(TypedValue.COMPLEX_UNIT_PT, 8);
			txtHeader.setTextSize(TypedValue.COMPLEX_UNIT_PT, 10);
			
			txtDataHosts.setTextColor(Color.GREEN);
			txtDataServices.setTextColor(Color.GREEN);
			
			switch(position){
				
			case 0:
				
				TextView txtDataHostsFlapping = new TextView(MonitoringFeaturesActivity.this);
				TextView txtDataServicesFlapping = new TextView(MonitoringFeaturesActivity.this);
				txtDataHostsFlapping.setTextSize(TypedValue.COMPLEX_UNIT_PT, 8);
				txtDataServicesFlapping.setTextSize(TypedValue.COMPLEX_UNIT_PT, 8);
				txtDataHostsFlapping.setTextColor(Color.GREEN);
				txtDataServicesFlapping.setTextColor(Color.GREEN);
				
				txtHeader.setText(R.string.flapDetection);
				txtDataServices.setText(currentTac.monitoringFeaturesSummary.servicesFlapDetection);
				txtDataServicesFlapping.setText(currentTac.monitoringFeaturesSummary.servicesFlapping);
				txtDataHosts.setText(currentTac.monitoringFeaturesSummary.hostsFlapDetection);
				txtDataHostsFlapping.setText(currentTac.monitoringFeaturesSummary.hostsFlapping);
				
				if(!currentTac.monitoringFeaturesSummary.servicesFlapDetection.contains("All Services Enabled")){
					txtDataServices.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.servicesFlapping.contains("No Services Flapping")){
					txtDataServicesFlapping.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsFlapDetection.contains("All Hosts Enabled")){
					txtDataHosts.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsFlapping.contains("No Hosts Flapping")){
					txtDataHostsFlapping.setTextColor(Color.RED);
				}
				
				ll.addView(txtHeader);
				ll.addView(txtDataServices);
				ll.addView(txtDataServicesFlapping);
				ll.addView(txtDataHosts);
				ll.addView(txtDataHostsFlapping);
				
				
				return ll;
				
			case 1:
				txtHeader.setText(R.string.notifications);
				
				txtDataServices.setText(currentTac.monitoringFeaturesSummary.servicesNotifications);
				txtDataHosts.setText(currentTac.monitoringFeaturesSummary.hostsNotifications);
				
				
				if(!currentTac.monitoringFeaturesSummary.servicesNotifications.contains("All Services Enabled")){
					txtDataServices.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsNotifications.contains("All Hosts Enabled")){
					txtDataHosts.setTextColor(Color.RED);
				}
				
				ll.addView(txtHeader);
				ll.addView(txtDataServices);
				ll.addView(txtDataHosts);
				
				return ll;
				
			case 2:
				txtHeader.setText(R.string.eventHandler);
				
				txtDataServices.setText(currentTac.monitoringFeaturesSummary.servicesEventHandlers);
				txtDataHosts.setText(currentTac.monitoringFeaturesSummary.hostsEventHandlers);
				
				if(!currentTac.monitoringFeaturesSummary.servicesEventHandlers.contains("All Services Enabled")){
					txtDataServices.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsEventHandlers.contains("All Hosts Enabled")){
					txtDataHosts.setTextColor(Color.RED);
				}
				
				ll.addView(txtHeader);
				ll.addView(txtDataServices);
				ll.addView(txtDataHosts);
				
				return ll;
				
			case 3:
				txtHeader.setText(R.string.activeChecks);
				
				txtDataServices.setText(currentTac.monitoringFeaturesSummary.servicesActiveChecks);
				txtDataHosts.setText(currentTac.monitoringFeaturesSummary.hostsActiveChecks);
				
				if(!currentTac.monitoringFeaturesSummary.servicesActiveChecks.contains("All Services Enabled")){
					txtDataServices.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsActiveChecks.contains("All Hosts Enabled")){
					txtDataHosts.setTextColor(Color.RED);
				}
				
				ll.addView(txtHeader);
				ll.addView(txtDataServices);
				ll.addView(txtDataHosts);
				
				return ll;
				
			case 4:
				txtHeader.setText(R.string.passiveChecks);
				
				txtDataServices.setText(currentTac.monitoringFeaturesSummary.servicesPassiveChecks);
				txtDataHosts.setText(currentTac.monitoringFeaturesSummary.hostsPassiveChecks);
				
				if(!currentTac.monitoringFeaturesSummary.servicesPassiveChecks.contains("All Services Enabled")){
					txtDataServices.setTextColor(Color.RED);
				}
				
				if(!currentTac.monitoringFeaturesSummary.hostsPassiveChecks.contains("All Hosts Enabled")){
					txtDataHosts.setTextColor(Color.RED);
				}
				
				ll.addView(txtHeader);
				ll.addView(txtDataServices);
				ll.addView(txtDataHosts);
				
				return ll;
			
			
			}
			
			return null;
			
		}
	}
	
	
	
	private class TacUpdateReceiver extends BroadcastReceiver{

		@Override
		public void onReceive(Context context, Intent intent) {
			update();
		}
		
	}
	
	
	private TacUpdateReceiver tacUpdateReceiver;
	private NagiosInstance instance;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		final IntentFilter intentFilter = new IntentFilter(AndrogiosActivity.ACTION_TAC_UPDATE);
		tacUpdateReceiver = new TacUpdateReceiver();
		getApplicationContext().registerReceiver(tacUpdateReceiver, intentFilter);
		
		setContentView(R.layout.monitoring_features_layout);
		instance = MasterController.getInstance().getActiveNagiosInstance();
		update();
	}
	
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	return MenuHelper.addDefaultMenu(menu);
    }
    
    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
    	return MenuHelper.updateServiceMenuItem(menu);
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	if(item.getItemId()==MenuHelper.REFRESH_ID){
    		poll();
    	}else if(item.getItemId()== MenuHelper.SERVICE_ID && !PollingService.running){
    		MasterController.getInstance().enableService();
    	}else if(item.getItemId()== MenuHelper.SERVICE_ID && PollingService.running){
    		MasterController.getInstance().disableService();
    	}else if(item.getItemId()== MenuHelper.CONFIGURE_ID){
    		Intent intent = new Intent();
    		intent.setClass(MasterController.getInstance().getAppCtx(), ConfigActivity.class);
    		startActivity(intent);
    	}//*/
    	return super.onOptionsItemSelected(item);
    }
	
	
	protected void update(){
		
		if(!instance.tacticalOverview.updateSuccessful){
			TextView txtHeader = ((TextView)findViewById(R.id.textViewMF));
			
			if(instance.tacticalOverview.errorCause == TacticalOverview.ERRORCAUSE_SSL){
    			txtHeader.setText(R.string.updatefailedSSL);
    		}else{
    			txtHeader.setText(R.string.updatefailed);
    		}
			
			return;
		}
		
		((TextView)findViewById(R.id.textViewMF)).setText(getString(R.string.lastUpdateHeader)+" "+DateHelper.simpleDate(instance.tacticalOverview.lastUpdate));
		
		ListView list = (ListView) findViewById(R.id.listViewMF);
		list.setAdapter(new MonitoringFeaturesAdapter());
	}
	
    
	
    protected void poll(){
    	((TextView)findViewById(R.id.textViewMF)).setText(R.string.polling);
		instance.pollTacticalOverview();
    }
    
    
    
	@Override
	protected void onResume() {
		super.onResume();
	}
	
	@Override
	protected void onPause() {
		super.onPause();
	}
	
	@Override
	protected void onDestroy(){
		super.onDestroy();
		getApplicationContext().unregisterReceiver(tacUpdateReceiver);
	}
    
}
