package at.jku.koppensteiner.androgios;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;
import at.jku.koppensteiner.androgios.nagios.MasterController;

public class NavigationActivity extends Activity{

	
	public class NavigationAdapter extends BaseAdapter{
		
		@Override
		public int getCount() {
			return 14;
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return getItem(position).hashCode();
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			
			TextView tv = new TextView(NavigationActivity.this);
			tv.setTextSize(TypedValue.COMPLEX_UNIT_PT, 12);

			switch(position){
			case 0:
				tv.setText(R.string.hostlist);
				return tv;
			case 1:
				tv.setText(R.string.hostgroups);
				return tv;
			case 2:
				tv.setText(R.string.hostproblems);
				return tv;
			case 3:
				tv.setText(R.string.hostlistfilter);
				return tv;
			case 4:
				tv.setText(R.string.servicelist);
				return tv;
			case 5:
				tv.setText(R.string.servicegroups);
				return tv;
			case 6:
				tv.setText(R.string.serviceproblems);
				return tv;
			case 7:
				tv.setText(R.string.servicelistfilter);
				return tv;
			case 8:
				tv.setText(R.string.outages);
				return tv;
			case 9:
				tv.setText(R.string.downtimes);
				return tv;
			case 10:
				tv.setText(R.string.hostcomments);
				return tv;
			case 11:
				tv.setText(R.string.servicecomments);
				return tv;
			case 12:
				tv.setText(R.string.nagiosprocess);
				return tv;
			case 13:
				tv.setText(R.string.monitoringfeatures);
				return tv;
				
			}
			
			
			
			return null;
		}

	}
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.navigation_layout);
        
        update();
    }
	
    private void update(){
    	ListView list = (ListView) findViewById(R.id.listViewNavi);
		list.setAdapter(new NavigationAdapter());
		list.setOnItemClickListener(new AdapterView.OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int pos,
					long id) {
				Intent intent = new Intent();
				switch(pos){
				case 0:
					intent.setClass(MasterController.getInstance().getAppCtx(), HostListActivity.class);
					intent.putExtra("FILTERED", false);
					break;
				case 1:
					intent.setClass(MasterController.getInstance().getAppCtx(), HostGroupsActivity.class);
					break;
				case 2:
					intent.setClass(MasterController.getInstance().getAppCtx(), HostProblemsActivity.class);
					break;
				case 3:
					intent.setClass(MasterController.getInstance().getAppCtx(), HostListFilterActivity.class);
					break;
				case 4:
					intent.setClass(MasterController.getInstance().getAppCtx(), ServiceListActivity.class);
					intent.putExtra("FILTERED", false);
					break;
				case 5:
					intent.setClass(MasterController.getInstance().getAppCtx(), ServiceGroupsActivity.class);
					break;
				case 6:
					intent.setClass(MasterController.getInstance().getAppCtx(), ServiceProblemsActivity.class);
					break;
				case 7:
					intent.setClass(MasterController.getInstance().getAppCtx(), ServiceListFilterActivity.class);
					break;
				case 8:
					intent.setClass(MasterController.getInstance().getAppCtx(), OutagesActivity.class);
					break;
				case 9:
					intent.setClass(MasterController.getInstance().getAppCtx(), DowntimesActivity.class);
					break;
				case 10:
					intent.setClass(MasterController.getInstance().getAppCtx(), HostCommentsActivity.class);
					break;
				case 11:
					intent.setClass(MasterController.getInstance().getAppCtx(), ServiceCommentsActivity.class);
					break;
				case 12:
					intent.setClass(MasterController.getInstance().getAppCtx(), ProcessDetailActivity.class);
					break;
				case 13:
					intent.setClass(MasterController.getInstance().getAppCtx(), MonitoringFeaturesActivity.class);
					break;
					
				}
				startActivity(intent);
			}
		});
	}
    
    
    
}
