package at.jku.koppensteiner.androgios;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import at.jku.koppensteiner.androgios.nagios.MasterController;
import at.jku.koppensteiner.androgios.util.FilterHelper;

public class ServiceListFilterActivity extends Activity{

	private class ServiceListFilterAdapter extends BaseAdapter{

		private LinearLayout llStatusTypes;
		private LinearLayout llProps;
		
		public ServiceListFilterAdapter(){
			init();
		}
		
		private void init(){
			llStatusTypes = new LinearLayout(ServiceListFilterActivity.this);
			llStatusTypes.setOrientation(LinearLayout.VERTICAL);
			for(int i=0;i<serviceStatusTypes.length;i++){
				serviceStatusTypes[i].setChecked(true);
				llStatusTypes.addView(serviceStatusTypes[i]);
			}
			
			llProps = new LinearLayout(ServiceListFilterActivity.this);
			llProps.setOrientation(LinearLayout.VERTICAL);
			for(int i=0;i<serviceProps.length;i++){
				llProps.addView(serviceProps[i]);
			}
		}
		
		@Override
		public int getCount() {
			return 2;
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return getItem(position).hashCode();
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			switch(position){
			case 0:
				return llProps;
			case 1:
				return llStatusTypes;
			}
			return null;
		}
		
	}
	
	private CheckBox[] serviceStatusTypes;
	private CheckBox[] serviceProps;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.service_list_filter_layout);
		
		serviceStatusTypes = FilterHelper.getServiceStatusTypeCheckBoxes(this);
		serviceProps = FilterHelper.getServicePropsCheckBoxes(this);
		
		update();
	}
	
	protected void update(){
		((TextView)findViewById(R.id.textViewServiceListFilter)).setText(R.string.chooseFilterCriteria);
		ListView list = (ListView) findViewById(R.id.listViewServiceListFilter);
		list.setAdapter(new ServiceListFilterAdapter());
		
		
		Button btn = ((Button)findViewById(R.id.buttonStartServiceListActivity));
		btn.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				int statusTypeParam = FilterHelper.getFilterParam(serviceStatusTypes);
				int propsParam = FilterHelper.getFilterParam(serviceProps);
				
				Intent intent = new Intent();
				intent.putExtra("FILTERED", true);
				intent.putExtra("SERVICESTATUSTYPES", statusTypeParam);
				intent.putExtra("SERVICEPROPS", propsParam);
				intent.setClass(MasterController.getInstance().getAppCtx(), ServiceListActivity.class);
				startActivity(intent);
			}
		});
	}
	
	
}
