package at.jku.koppensteiner.androgios.nagios.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Host {

	public String hostName = "";
	public String hostStatus = "";
	public String hostStatusDetail = "";
	public String statusInformation = "";
	public String performanceData = "";
	public String currentAttempt = "";
	public String lastCheckTime = "";
	public String checkType = "";
	public String checkLatencyDuration = "";
	public String nextScheduledActiveCheck = "";
	public String lastStateChange = "";
	public String lastNotification = "";
	public String isThisHostFlapping = "";
	public String inScheduledDowntime = "";
	public String lastUpdate = "";
	
	public String activeChecks = "";
	public String passiveChecks = "";
	public String obsessing = "";
	public String notifications = "";
	public String eventHandler = "";
	public String flapDetection = "";
	
//	public List<HostComment> comments;
	public List<Service> hostServices;
	
	public Host(){
		
//		comments = new ArrayList<HostComment>();
		hostServices = new ArrayList<Service>();
	}
	
	public int getServicePosition(String serviceName){
		Iterator<Service> it =  hostServices.iterator();
		int cnt = 0;
		while(it.hasNext()){
			Service s = it.next();
			if(s.serviceName.equals(serviceName)) return cnt;
			cnt++;
		}
		
		return -1;
	}
	
	@Override
	public Object clone(){
		Host clone = new Host();
		
		clone.hostName = new String(hostName);
		clone.hostStatus = new String(hostStatus);
		clone.hostStatusDetail = new String(hostStatusDetail);
		clone.statusInformation = new String(statusInformation);
		clone.performanceData = new String(performanceData);
		clone.currentAttempt = new String(currentAttempt);
		clone.lastCheckTime = new String(lastCheckTime);
		clone.checkType = new String(checkType);
		clone.checkLatencyDuration = new String(checkLatencyDuration);
		clone.nextScheduledActiveCheck = new String(nextScheduledActiveCheck);
		clone.lastStateChange = new String(lastStateChange);
		clone.lastNotification = new String(lastNotification);
		clone.isThisHostFlapping = new String(isThisHostFlapping);
		clone.inScheduledDowntime = new String(inScheduledDowntime);
		clone.lastUpdate = new String(lastUpdate);
		
		clone.activeChecks = new String(activeChecks);
		clone.passiveChecks = new String(passiveChecks);
		clone.obsessing = new String(obsessing);
		clone.notifications = new String(notifications);
		clone.eventHandler = new String(eventHandler);
		clone.flapDetection = new String(flapDetection);
		
//		for(HostComment hc : comments){
//			clone.comments.add((HostComment) hc.clone());
//		}
		
		for(Service s : hostServices){
			clone.hostServices.add((Service)s.clone());
		}
		
		return clone;
	}
	
}
