package at.jku.koppensteiner.androgios.nagios.model;

import java.util.Date;

public class TacticalOverview {

	public static final int ERRORCAUSE_SSL = 1;
	public static final int ERRORCAUSE_PARSING = 2;
	
	public String hostHealth;
	public String serviceHealth;
	public OutagesSummary outagesSummary;
	public HostStatusSummary hostStatusSummary;
	public ServiceStatusSummary serviceStatusSummary;
	public MonitoringFeaturesSummary monitoringFeaturesSummary;
	
	public Date lastUpdate;
	public boolean updateSuccessful;
	public int errorCause;
	
	public boolean hasUnimportantOutageProblem;
	public boolean hasImportantOutageProblem;
	public boolean hasUnimportantHostProblem;
	public boolean hasImportantHostProblem;
	public boolean hasUnimportantServiceProblem;
	public boolean hasImportantServiceProblem;
	
	public TacticalOverview(){
		init();
	}
	
	public void reset(){
		init();
	}
	
	private void init(){
		hostHealth = "";
		serviceHealth = "";
		outagesSummary = new OutagesSummary();
		hostStatusSummary = new HostStatusSummary();
		serviceStatusSummary = new ServiceStatusSummary();
		monitoringFeaturesSummary = new MonitoringFeaturesSummary();
		lastUpdate = null; 
		updateSuccessful = false;
		errorCause = 0;
		hasUnimportantOutageProblem = false;
		hasImportantOutageProblem = false;
		hasUnimportantHostProblem = false;
		hasImportantHostProblem = false;
		hasUnimportantServiceProblem = false;
		hasImportantServiceProblem = false;
	}
	
	public boolean hasImportantProblem(){
		return hasImportantHostProblem||hasImportantServiceProblem;//||hasImportantOutageProblem;
	}
	
	public boolean hasUnimportantProblem(){
		return hasUnimportantHostProblem||hasUnimportantServiceProblem||hasUnimportantOutageProblem;
	}
	
}
