package at.jku.koppensteiner.androgios.net;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;

import javax.net.ssl.HttpsURLConnection;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import at.jku.koppensteiner.androgios.util.SSLHelper;



public class CmdSender {
	
	private String url;
	private String username;
	private String password;
	private boolean acceptSelfSignedCert;
	
	
	public CmdSender(String url, String username, String password, boolean acceptSelfSignedCert){
		this.url = url;
		this.username = username;
		this.password = password;
		this.acceptSelfSignedCert = acceptSelfSignedCert;
	}
	
	public String send(String postData){
		int tryNr = 1;
		
		while(tryNr<=3){
			try {
				return trySend(postData); 
			}catch (Exception e) {
				tryNr++;
			}
		}
		
		return "Connection Error";
	}
	
	private String trySend(String postData) throws Exception  {
		
	    URL url = new URL(this.url);
	    URLConnection c = url.openConnection();
	    
	    
	    if(c instanceof HttpsURLConnection && acceptSelfSignedCert){
	    	((HttpsURLConnection)c).setHostnameVerifier(SSLHelper.ACCEPT_ALL_VERIFIER);
	    }
	    
	    
	    c.setRequestProperty("Authorization", "Basic "
				+ Base64.encodeString(username + ":" + password));
	    
	    c.setDoOutput(true);
	    OutputStreamWriter wr = new OutputStreamWriter(c.getOutputStream());
	    wr.write(postData);
	    wr.flush();

	    // Get the response
	    BufferedReader rd = new BufferedReader(new InputStreamReader(c.getInputStream()));
	    StringBuffer sb = new StringBuffer();
	    String line;
	    while ((line = rd.readLine()) != null) {
	        sb.append(line);
	        sb.append("\n");
	    }
	    
	    rd.close();
	    wr.close();
	    
	    return getReturnMessage(sb.toString()); 
		    
//*/ 
		
	}
	
	private String getReturnMessage(String html) throws Exception{
		Document doc = Jsoup.parse(html);
		return doc.select("div.infoMessage, div.errorMessage").get(0).text();
	}
	
	

	
}
