package at.jku.koppensteiner.androgios.parser;

import java.util.Date;
import java.util.Iterator;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;


import at.jku.koppensteiner.androgios.nagios.NagiosInstance;
import at.jku.koppensteiner.androgios.nagios.model.HostComment;
import at.jku.koppensteiner.androgios.nagios.model.MonitoringModel;
import at.jku.koppensteiner.androgios.nagios.model.ServiceComment;

public class CommentsParser extends Parser{

	public CommentsParser(String html, NagiosInstance instance) {
		super(html, instance);
	}

	
	protected void updateModel() {
		
		MonitoringModel model = new MonitoringModel();
		model.lastParsed = MonitoringModel.COMMENTS;
		
		
		Document doc = Jsoup.parse(html);
		
		Element hostCommentsTable = doc.select("table.comment").get(0);
		Element serviceCommentsTable = doc.select("table.comment").get(1);
		
		Elements rows = hostCommentsTable.select("> * > tr");
		Iterator<Element> it = rows.iterator();
		it.next();
		HostComment hostComment;
		
		while(it.hasNext()){
			Element row = it.next();
			Elements rowData = row.select(" > td");
			if(rowData.size()==1)continue; //table is empty
			
			hostComment = new HostComment();
			
			hostComment.hostName = rowData.get(0).text();
			hostComment.entryTime = rowData.get(1).text();
			hostComment.author = rowData.get(2).text();
			hostComment.comment = rowData.get(3).text();
			hostComment.commentId = rowData.get(4).text();
			hostComment.persistent = rowData.get(5).text();
			hostComment.type = rowData.get(6).text();
			hostComment.expires = rowData.get(7).text();
			
			model.hostComments.add(hostComment);
			
		}
		
		rows = serviceCommentsTable.select("> * > tr");
		it = rows.iterator();
		it.next();
		ServiceComment serviceComment;
		
		while(it.hasNext()){
			Element row = it.next();
			Elements rowData = row.select(" > td");
			if(rowData.size()==1)continue; //table is empty
			
			serviceComment = new ServiceComment();
			
			serviceComment.hostName = rowData.get(0).text();
			serviceComment.serviceName = rowData.get(1).text();
			serviceComment.entryTime = rowData.get(2).text();
			serviceComment.author = rowData.get(3).text();
			serviceComment.comment = rowData.get(4).text();
			serviceComment.commentId = rowData.get(5).text();
			serviceComment.persistent = rowData.get(6).text();
			serviceComment.type = rowData.get(7).text();
			serviceComment.expires = rowData.get(8).text();
			
			model.serviceComments.add(serviceComment);
			
		}
		
		
		model.lastUpdate = new Date(System.currentTimeMillis());
		model.updateSuccessful = true;
		instance.model = model;
	}

}
