package at.jku.koppensteiner.androgios.parser;

import java.util.Date;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

import at.jku.koppensteiner.androgios.nagios.NagiosInstance;
import at.jku.koppensteiner.androgios.nagios.model.MonitoringModel;

public class ProcessDetailParser extends Parser{

	public ProcessDetailParser(String html, NagiosInstance instance) {
		super(html, instance);
	}

	@Override
	protected void updateModel(){
		
		MonitoringModel model = new MonitoringModel();
		model.lastParsed = MonitoringModel.NAGIOSPROCESS;
		
		Document doc = Jsoup.parse(html);
		
		Elements vals = doc.select("[class=dataval]");
		
		model.process.programVersion = vals.get(0).text();
		model.process.programStartTime = vals.get(1).text();
		model.process.totalRunningTime = vals.get(2).text();
		model.process.lastExternalCommandCheck = vals.get(3).text();
		model.process.lastLogFileRotation = vals.get(4).text();
		model.process.nagiosPID = vals.get(5).text();
		model.process.notificationsEnabled = vals.get(6).text();
		
		model.process.serviceChecksBeingExecuted = vals.get(7).text();
		model.process.passiveServiceChecksBeingAccepted = vals.get(8).text();
		model.process.hostChecksBeingExecuted = vals.get(9).text();
		model.process.passiveHostChecksBeingAccepted = vals.get(10).text();
		
		model.process.eventHandlersEnabled = vals.get(11).text();
		model.process.obsessingOverServices = vals.get(12).text();
		model.process.obsessingOverHosts = vals.get(13).text();
		model.process.flapDetectionEnabled = vals.get(14).text();
		model.process.performanceDataBeingProcessed = vals.get(15).text();
		
		
		model.lastUpdate = new Date(System.currentTimeMillis());
		model.updateSuccessful = true;
		instance.model = model;
	}

}
