package at.jku.koppensteiner.androgios.util;

import android.content.Context;
import android.widget.CheckBox;

public class FilterHelper {

	
	private final static String[] HOSTSTATUSTYPES = new String[]{"PENDING","UP","DOWN","UNREACHABLE"};
	private final static String[] SERVICESTATUSTYPES = new String[]{"PENDING","OK","WARNING","UNKNOWN","CRITICAL"};
	private final static String[] HOSTPROPS = 
		new String[]{"Scheduled Downtime","No Scheduled Downtime", 
		"Acknowledged","Not Acknowledged",
		"Host-Checks disabled","Host-Checks enabled",
		"Eventhandler disabled","Eventhandler enabled",
		"Flap Detection disabled","Flap Detection enabled",
		"Host Flapping","Host not Flapping",
		"Host Notifications disabled","Host Notifications enabled",
		"Passive Host-Checks disabled","Passive Host-Checks enabled",
		"Hosts with passive check result","Hosts with active check result"};
	private final static String[] SERVICEPROPS = 
		new String[]{"Scheduled Downtime","No Scheduled Downtime", 
		"Acknowledged","Not Acknowledged",
		"Service-Checks disabled","Service-Checks enabled",
		"Eventhandler disabled","Eventhandler enabled",
		"Flap Detection enabled","Flap Detection disabled",
		"Service Flapping","Service not Flapping",
		"Service Notifications disabled","Service Notifications enabled",
		"Passive Service-Checks disabled","Passive Service-Checks enabled",
		"Services with passive check result","Services with active check result"};
	
	public static CheckBox[] getHostStatusTypeCheckBoxes(Context context){
		return getCheckBoxes(context, HOSTSTATUSTYPES);
	}
	
	public static CheckBox[] getServiceStatusTypeCheckBoxes(Context context){
		return getCheckBoxes(context, SERVICESTATUSTYPES);
	}
	
	public static CheckBox[] getHostPropsCheckBoxes(Context context){
		return getCheckBoxes(context, HOSTPROPS);
	}
	
	public static CheckBox[] getServicePropsCheckBoxes(Context context){
		return getCheckBoxes(context, SERVICEPROPS);
	}
	
	public static int getFilterParam(CheckBox[] checkBoxes){
		
		int param = 0;
		
		for(int i=0;i<checkBoxes.length;i++){
			if(checkBoxes[i].isChecked()){
				param +=   0x1<<i;
			}
		}
		
		return param;
	}
	
	
	
	private static CheckBox[] getCheckBoxes(final Context context, String[] strings){
		
		
		
		CheckBox[] checkBoxes = new CheckBox[strings.length];
		
		for(int i=0;i<checkBoxes.length;i++){
			CheckBox cb = new CheckBox(context);
			cb.setText(strings[i]);
			checkBoxes[i] = cb;
		}
		
		return checkBoxes;
	}
	
}
