package at.jku.koppensteiner.androgios.util;

import android.view.Menu;
import at.jku.koppensteiner.androgios.R;
import at.jku.koppensteiner.androgios.service.PollingService;

public class MenuHelper {

	public static int REFRESH_ID = 0;
	public static int CONFIGURE_ID = 1;
	public static int SERVICE_ID = 2;
	
	
	
	public static boolean addDefaultMenu(Menu menu){
		menu.add(0, REFRESH_ID, 0, R.string.refresh).setIcon(android.R.drawable.ic_menu_rotate);
		menu.add(0, CONFIGURE_ID, 0, R.string.configure).setIcon(android.R.drawable.ic_menu_compass);
		
		if(PollingService.running){
			menu.add(0, SERVICE_ID, 0, R.string.disableService).setIcon(android.R.drawable.ic_media_pause);
		}else{
			menu.add(0, SERVICE_ID, 0, R.string.enableService).setIcon(android.R.drawable.ic_media_play);
		}
    	
    	return true;
	}
	
	public static boolean updateServiceMenuItem(Menu menu){
		menu.removeItem(SERVICE_ID);
		if(PollingService.running){
			menu.add(0, SERVICE_ID, 0, R.string.disableService).setIcon(android.R.drawable.ic_media_pause);
		}else{
			menu.add(0, SERVICE_ID, 0, R.string.enableService).setIcon(android.R.drawable.ic_media_play);
		}
		return true;
	}
	
}
